// This file was auto-generated by the veyron vdl tool.
// Source: namespace.vdl

// Package namespace defines an RPC services that allows remoting of the
// namespace client library over the wire.  This is useful for
// javascript so it doesn't have to implement the library.
// This should be kept in sync with the namespace library (v.io/v23/naming).
package namespace

import (
	// VDL system imports
	"io"
	"v.io/v23"
	"v.io/v23/context"
	"v.io/v23/ipc"

	// VDL user imports
	"time"
	"v.io/v23/naming"
	"v.io/v23/security"
	"v.io/v23/services/security/access"
	_ "v.io/v23/vdlroot/time"
)

// WorkaroundClientMethods is the client interface
// containing Workaround methods.
//
// TODO(nlacasse,bprosnitz): Remove this unused type and the security import
// once https://github.com/veyron/release-issues/issues/1202 is fixed.
type WorkaroundClientMethods interface {
	Unused(ctx *context.T, unused security.BlessingPattern, opts ...ipc.CallOpt) error
}

// WorkaroundClientStub adds universal methods to WorkaroundClientMethods.
type WorkaroundClientStub interface {
	WorkaroundClientMethods
	ipc.UniversalServiceMethods
}

// WorkaroundClient returns a client stub for Workaround.
func WorkaroundClient(name string, opts ...ipc.BindOpt) WorkaroundClientStub {
	var client ipc.Client
	for _, opt := range opts {
		if clientOpt, ok := opt.(ipc.Client); ok {
			client = clientOpt
		}
	}
	return implWorkaroundClientStub{name, client}
}

type implWorkaroundClientStub struct {
	name   string
	client ipc.Client
}

func (c implWorkaroundClientStub) c(ctx *context.T) ipc.Client {
	if c.client != nil {
		return c.client
	}
	return v23.GetClient(ctx)
}

func (c implWorkaroundClientStub) Unused(ctx *context.T, i0 security.BlessingPattern, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Unused", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

// WorkaroundServerMethods is the interface a server writer
// implements for Workaround.
//
// TODO(nlacasse,bprosnitz): Remove this unused type and the security import
// once https://github.com/veyron/release-issues/issues/1202 is fixed.
type WorkaroundServerMethods interface {
	Unused(ctx ipc.ServerContext, unused security.BlessingPattern) error
}

// WorkaroundServerStubMethods is the server interface containing
// Workaround methods, as expected by ipc.Server.
// There is no difference between this interface and WorkaroundServerMethods
// since there are no streaming methods.
type WorkaroundServerStubMethods WorkaroundServerMethods

// WorkaroundServerStub adds universal methods to WorkaroundServerStubMethods.
type WorkaroundServerStub interface {
	WorkaroundServerStubMethods
	// Describe the Workaround interfaces.
	Describe__() []ipc.InterfaceDesc
}

// WorkaroundServer returns a server stub for Workaround.
// It converts an implementation of WorkaroundServerMethods into
// an object that may be used by ipc.Server.
func WorkaroundServer(impl WorkaroundServerMethods) WorkaroundServerStub {
	stub := implWorkaroundServerStub{
		impl: impl,
	}
	// Initialize GlobState; always check the stub itself first, to handle the
	// case where the user has the Glob method defined in their VDL source.
	if gs := ipc.NewGlobState(stub); gs != nil {
		stub.gs = gs
	} else if gs := ipc.NewGlobState(impl); gs != nil {
		stub.gs = gs
	}
	return stub
}

type implWorkaroundServerStub struct {
	impl WorkaroundServerMethods
	gs   *ipc.GlobState
}

func (s implWorkaroundServerStub) Unused(ctx ipc.ServerContext, i0 security.BlessingPattern) error {
	return s.impl.Unused(ctx, i0)
}

func (s implWorkaroundServerStub) Globber() *ipc.GlobState {
	return s.gs
}

func (s implWorkaroundServerStub) Describe__() []ipc.InterfaceDesc {
	return []ipc.InterfaceDesc{WorkaroundDesc}
}

// WorkaroundDesc describes the Workaround interface.
var WorkaroundDesc ipc.InterfaceDesc = descWorkaround

// descWorkaround hides the desc to keep godoc clean.
var descWorkaround = ipc.InterfaceDesc{
	Name:    "Workaround",
	PkgPath: "v.io/core/veyron/services/wsprd/namespace",
	Doc:     "// TODO(nlacasse,bprosnitz): Remove this unused type and the security import\n// once https://github.com/veyron/release-issues/issues/1202 is fixed.",
	Methods: []ipc.MethodDesc{
		{
			Name: "Unused",
			InArgs: []ipc.ArgDesc{
				{"unused", ``}, // security.BlessingPattern
			},
		},
	},
}

// NamespaceClientMethods is the client interface
// containing Namespace methods.
type NamespaceClientMethods interface {
	// Run a glob query and stream the results.
	Glob(ctx *context.T, pattern string, opts ...ipc.CallOpt) (NamespaceGlobCall, error)
	// Mount mounts a server under the given name.
	Mount(ctx *context.T, name string, server string, ttl time.Duration, replace bool, opts ...ipc.CallOpt) error
	// Unmount removes an existing mount point.
	Unmount(ctx *context.T, name string, server string, opts ...ipc.CallOpt) error
	// Resolve resolves a name to an address.
	Resolve(ctx *context.T, name string, opts ...ipc.CallOpt) ([]string, error)
	// ResolveToMt resolves a name to the address of the mounttable directly
	// hosting it.
	ResolveToMT(ctx *context.T, name string, opts ...ipc.CallOpt) ([]string, error)
	// FlushCacheEntry removes the namespace cache entry for a given name.
	FlushCacheEntry(ctx *context.T, name string, opts ...ipc.CallOpt) (bool, error)
	// DisableCache disables the naming cache.
	DisableCache(ctx *context.T, disable bool, opts ...ipc.CallOpt) error
	// Roots returns the addresses of the current mounttable roots.
	Roots(*context.T, ...ipc.CallOpt) ([]string, error)
	// SetRoots sets the current mounttable roots.
	SetRoots(ctx *context.T, roots []string, opts ...ipc.CallOpt) error
	// SetACL sets the ACL in a node in a mount table.
	SetACL(ctx *context.T, name string, acl access.TaggedACLMap, etag string, opts ...ipc.CallOpt) error
	// GetACL returns the ACL in a node in a mount table.
	GetACL(ctx *context.T, name string, opts ...ipc.CallOpt) (acl access.TaggedACLMap, etag string, err error)
}

// NamespaceClientStub adds universal methods to NamespaceClientMethods.
type NamespaceClientStub interface {
	NamespaceClientMethods
	ipc.UniversalServiceMethods
}

// NamespaceClient returns a client stub for Namespace.
func NamespaceClient(name string, opts ...ipc.BindOpt) NamespaceClientStub {
	var client ipc.Client
	for _, opt := range opts {
		if clientOpt, ok := opt.(ipc.Client); ok {
			client = clientOpt
		}
	}
	return implNamespaceClientStub{name, client}
}

type implNamespaceClientStub struct {
	name   string
	client ipc.Client
}

func (c implNamespaceClientStub) c(ctx *context.T) ipc.Client {
	if c.client != nil {
		return c.client
	}
	return v23.GetClient(ctx)
}

func (c implNamespaceClientStub) Glob(ctx *context.T, i0 string, opts ...ipc.CallOpt) (ocall NamespaceGlobCall, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Glob", []interface{}{i0}, opts...); err != nil {
		return
	}
	ocall = &implNamespaceGlobCall{Call: call}
	return
}

func (c implNamespaceClientStub) Mount(ctx *context.T, i0 string, i1 string, i2 time.Duration, i3 bool, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Mount", []interface{}{i0, i1, i2, i3}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

func (c implNamespaceClientStub) Unmount(ctx *context.T, i0 string, i1 string, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Unmount", []interface{}{i0, i1}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

func (c implNamespaceClientStub) Resolve(ctx *context.T, i0 string, opts ...ipc.CallOpt) (o0 []string, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Resolve", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish(&o0)
	return
}

func (c implNamespaceClientStub) ResolveToMT(ctx *context.T, i0 string, opts ...ipc.CallOpt) (o0 []string, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "ResolveToMT", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish(&o0)
	return
}

func (c implNamespaceClientStub) FlushCacheEntry(ctx *context.T, i0 string, opts ...ipc.CallOpt) (o0 bool, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "FlushCacheEntry", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish(&o0)
	return
}

func (c implNamespaceClientStub) DisableCache(ctx *context.T, i0 bool, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "DisableCache", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

func (c implNamespaceClientStub) Roots(ctx *context.T, opts ...ipc.CallOpt) (o0 []string, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "Roots", nil, opts...); err != nil {
		return
	}
	err = call.Finish(&o0)
	return
}

func (c implNamespaceClientStub) SetRoots(ctx *context.T, i0 []string, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "SetRoots", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

func (c implNamespaceClientStub) SetACL(ctx *context.T, i0 string, i1 access.TaggedACLMap, i2 string, opts ...ipc.CallOpt) (err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "SetACL", []interface{}{i0, i1, i2}, opts...); err != nil {
		return
	}
	err = call.Finish()
	return
}

func (c implNamespaceClientStub) GetACL(ctx *context.T, i0 string, opts ...ipc.CallOpt) (o0 access.TaggedACLMap, o1 string, err error) {
	var call ipc.Call
	if call, err = c.c(ctx).StartCall(ctx, c.name, "GetACL", []interface{}{i0}, opts...); err != nil {
		return
	}
	err = call.Finish(&o0, &o1)
	return
}

// NamespaceGlobClientStream is the client stream for Namespace.Glob.
type NamespaceGlobClientStream interface {
	// RecvStream returns the receiver side of the Namespace.Glob client stream.
	RecvStream() interface {
		// Advance stages an item so that it may be retrieved via Value.  Returns
		// true iff there is an item to retrieve.  Advance must be called before
		// Value is called.  May block if an item is not available.
		Advance() bool
		// Value returns the item that was staged by Advance.  May panic if Advance
		// returned false or was not called.  Never blocks.
		Value() naming.VDLGlobReply
		// Err returns any error encountered by Advance.  Never blocks.
		Err() error
	}
}

// NamespaceGlobCall represents the call returned from Namespace.Glob.
type NamespaceGlobCall interface {
	NamespaceGlobClientStream
	// Finish blocks until the server is done, and returns the positional return
	// values for call.
	//
	// Finish returns immediately if the call has been canceled; depending on the
	// timing the output could either be an error signaling cancelation, or the
	// valid positional return values from the server.
	//
	// Calling Finish is mandatory for releasing stream resources, unless the call
	// has been canceled or any of the other methods return an error.  Finish should
	// be called at most once.
	Finish() error
}

type implNamespaceGlobCall struct {
	ipc.Call
	valRecv naming.VDLGlobReply
	errRecv error
}

func (c *implNamespaceGlobCall) RecvStream() interface {
	Advance() bool
	Value() naming.VDLGlobReply
	Err() error
} {
	return implNamespaceGlobCallRecv{c}
}

type implNamespaceGlobCallRecv struct {
	c *implNamespaceGlobCall
}

func (c implNamespaceGlobCallRecv) Advance() bool {
	c.c.errRecv = c.c.Recv(&c.c.valRecv)
	return c.c.errRecv == nil
}
func (c implNamespaceGlobCallRecv) Value() naming.VDLGlobReply {
	return c.c.valRecv
}
func (c implNamespaceGlobCallRecv) Err() error {
	if c.c.errRecv == io.EOF {
		return nil
	}
	return c.c.errRecv
}
func (c *implNamespaceGlobCall) Finish() (err error) {
	err = c.Call.Finish()
	return
}

// NamespaceServerMethods is the interface a server writer
// implements for Namespace.
type NamespaceServerMethods interface {
	// Run a glob query and stream the results.
	Glob(ctx NamespaceGlobContext, pattern string) error
	// Mount mounts a server under the given name.
	Mount(ctx ipc.ServerContext, name string, server string, ttl time.Duration, replace bool) error
	// Unmount removes an existing mount point.
	Unmount(ctx ipc.ServerContext, name string, server string) error
	// Resolve resolves a name to an address.
	Resolve(ctx ipc.ServerContext, name string) ([]string, error)
	// ResolveToMt resolves a name to the address of the mounttable directly
	// hosting it.
	ResolveToMT(ctx ipc.ServerContext, name string) ([]string, error)
	// FlushCacheEntry removes the namespace cache entry for a given name.
	FlushCacheEntry(ctx ipc.ServerContext, name string) (bool, error)
	// DisableCache disables the naming cache.
	DisableCache(ctx ipc.ServerContext, disable bool) error
	// Roots returns the addresses of the current mounttable roots.
	Roots(ipc.ServerContext) ([]string, error)
	// SetRoots sets the current mounttable roots.
	SetRoots(ctx ipc.ServerContext, roots []string) error
	// SetACL sets the ACL in a node in a mount table.
	SetACL(ctx ipc.ServerContext, name string, acl access.TaggedACLMap, etag string) error
	// GetACL returns the ACL in a node in a mount table.
	GetACL(ctx ipc.ServerContext, name string) (acl access.TaggedACLMap, etag string, err error)
}

// NamespaceServerStubMethods is the server interface containing
// Namespace methods, as expected by ipc.Server.
// The only difference between this interface and NamespaceServerMethods
// is the streaming methods.
type NamespaceServerStubMethods interface {
	// Run a glob query and stream the results.
	Glob(ctx *NamespaceGlobContextStub, pattern string) error
	// Mount mounts a server under the given name.
	Mount(ctx ipc.ServerContext, name string, server string, ttl time.Duration, replace bool) error
	// Unmount removes an existing mount point.
	Unmount(ctx ipc.ServerContext, name string, server string) error
	// Resolve resolves a name to an address.
	Resolve(ctx ipc.ServerContext, name string) ([]string, error)
	// ResolveToMt resolves a name to the address of the mounttable directly
	// hosting it.
	ResolveToMT(ctx ipc.ServerContext, name string) ([]string, error)
	// FlushCacheEntry removes the namespace cache entry for a given name.
	FlushCacheEntry(ctx ipc.ServerContext, name string) (bool, error)
	// DisableCache disables the naming cache.
	DisableCache(ctx ipc.ServerContext, disable bool) error
	// Roots returns the addresses of the current mounttable roots.
	Roots(ipc.ServerContext) ([]string, error)
	// SetRoots sets the current mounttable roots.
	SetRoots(ctx ipc.ServerContext, roots []string) error
	// SetACL sets the ACL in a node in a mount table.
	SetACL(ctx ipc.ServerContext, name string, acl access.TaggedACLMap, etag string) error
	// GetACL returns the ACL in a node in a mount table.
	GetACL(ctx ipc.ServerContext, name string) (acl access.TaggedACLMap, etag string, err error)
}

// NamespaceServerStub adds universal methods to NamespaceServerStubMethods.
type NamespaceServerStub interface {
	NamespaceServerStubMethods
	// Describe the Namespace interfaces.
	Describe__() []ipc.InterfaceDesc
}

// NamespaceServer returns a server stub for Namespace.
// It converts an implementation of NamespaceServerMethods into
// an object that may be used by ipc.Server.
func NamespaceServer(impl NamespaceServerMethods) NamespaceServerStub {
	stub := implNamespaceServerStub{
		impl: impl,
	}
	// Initialize GlobState; always check the stub itself first, to handle the
	// case where the user has the Glob method defined in their VDL source.
	if gs := ipc.NewGlobState(stub); gs != nil {
		stub.gs = gs
	} else if gs := ipc.NewGlobState(impl); gs != nil {
		stub.gs = gs
	}
	return stub
}

type implNamespaceServerStub struct {
	impl NamespaceServerMethods
	gs   *ipc.GlobState
}

func (s implNamespaceServerStub) Glob(ctx *NamespaceGlobContextStub, i0 string) error {
	return s.impl.Glob(ctx, i0)
}

func (s implNamespaceServerStub) Mount(ctx ipc.ServerContext, i0 string, i1 string, i2 time.Duration, i3 bool) error {
	return s.impl.Mount(ctx, i0, i1, i2, i3)
}

func (s implNamespaceServerStub) Unmount(ctx ipc.ServerContext, i0 string, i1 string) error {
	return s.impl.Unmount(ctx, i0, i1)
}

func (s implNamespaceServerStub) Resolve(ctx ipc.ServerContext, i0 string) ([]string, error) {
	return s.impl.Resolve(ctx, i0)
}

func (s implNamespaceServerStub) ResolveToMT(ctx ipc.ServerContext, i0 string) ([]string, error) {
	return s.impl.ResolveToMT(ctx, i0)
}

func (s implNamespaceServerStub) FlushCacheEntry(ctx ipc.ServerContext, i0 string) (bool, error) {
	return s.impl.FlushCacheEntry(ctx, i0)
}

func (s implNamespaceServerStub) DisableCache(ctx ipc.ServerContext, i0 bool) error {
	return s.impl.DisableCache(ctx, i0)
}

func (s implNamespaceServerStub) Roots(ctx ipc.ServerContext) ([]string, error) {
	return s.impl.Roots(ctx)
}

func (s implNamespaceServerStub) SetRoots(ctx ipc.ServerContext, i0 []string) error {
	return s.impl.SetRoots(ctx, i0)
}

func (s implNamespaceServerStub) SetACL(ctx ipc.ServerContext, i0 string, i1 access.TaggedACLMap, i2 string) error {
	return s.impl.SetACL(ctx, i0, i1, i2)
}

func (s implNamespaceServerStub) GetACL(ctx ipc.ServerContext, i0 string) (access.TaggedACLMap, string, error) {
	return s.impl.GetACL(ctx, i0)
}

func (s implNamespaceServerStub) Globber() *ipc.GlobState {
	return s.gs
}

func (s implNamespaceServerStub) Describe__() []ipc.InterfaceDesc {
	return []ipc.InterfaceDesc{NamespaceDesc}
}

// NamespaceDesc describes the Namespace interface.
var NamespaceDesc ipc.InterfaceDesc = descNamespace

// descNamespace hides the desc to keep godoc clean.
var descNamespace = ipc.InterfaceDesc{
	Name:    "Namespace",
	PkgPath: "v.io/core/veyron/services/wsprd/namespace",
	Methods: []ipc.MethodDesc{
		{
			Name: "Glob",
			Doc:  "// Run a glob query and stream the results.",
			InArgs: []ipc.ArgDesc{
				{"pattern", ``}, // string
			},
		},
		{
			Name: "Mount",
			Doc:  "// Mount mounts a server under the given name.",
			InArgs: []ipc.ArgDesc{
				{"name", ``},    // string
				{"server", ``},  // string
				{"ttl", ``},     // time.Duration
				{"replace", ``}, // bool
			},
		},
		{
			Name: "Unmount",
			Doc:  "// Unmount removes an existing mount point.",
			InArgs: []ipc.ArgDesc{
				{"name", ``},   // string
				{"server", ``}, // string
			},
		},
		{
			Name: "Resolve",
			Doc:  "// Resolve resolves a name to an address.",
			InArgs: []ipc.ArgDesc{
				{"name", ``}, // string
			},
			OutArgs: []ipc.ArgDesc{
				{"", ``}, // []string
			},
		},
		{
			Name: "ResolveToMT",
			Doc:  "// ResolveToMt resolves a name to the address of the mounttable directly\n// hosting it.",
			InArgs: []ipc.ArgDesc{
				{"name", ``}, // string
			},
			OutArgs: []ipc.ArgDesc{
				{"", ``}, // []string
			},
		},
		{
			Name: "FlushCacheEntry",
			Doc:  "// FlushCacheEntry removes the namespace cache entry for a given name.",
			InArgs: []ipc.ArgDesc{
				{"name", ``}, // string
			},
			OutArgs: []ipc.ArgDesc{
				{"", ``}, // bool
			},
		},
		{
			Name: "DisableCache",
			Doc:  "// DisableCache disables the naming cache.",
			InArgs: []ipc.ArgDesc{
				{"disable", ``}, // bool
			},
		},
		{
			Name: "Roots",
			Doc:  "// Roots returns the addresses of the current mounttable roots.",
			OutArgs: []ipc.ArgDesc{
				{"", ``}, // []string
			},
		},
		{
			Name: "SetRoots",
			Doc:  "// SetRoots sets the current mounttable roots.",
			InArgs: []ipc.ArgDesc{
				{"roots", ``}, // []string
			},
		},
		{
			Name: "SetACL",
			Doc:  "// SetACL sets the ACL in a node in a mount table.",
			InArgs: []ipc.ArgDesc{
				{"name", ``}, // string
				{"acl", ``},  // access.TaggedACLMap
				{"etag", ``}, // string
			},
		},
		{
			Name: "GetACL",
			Doc:  "// GetACL returns the ACL in a node in a mount table.",
			InArgs: []ipc.ArgDesc{
				{"name", ``}, // string
			},
			OutArgs: []ipc.ArgDesc{
				{"acl", ``},  // access.TaggedACLMap
				{"etag", ``}, // string
			},
		},
	},
}

// NamespaceGlobServerStream is the server stream for Namespace.Glob.
type NamespaceGlobServerStream interface {
	// SendStream returns the send side of the Namespace.Glob server stream.
	SendStream() interface {
		// Send places the item onto the output stream.  Returns errors encountered
		// while sending.  Blocks if there is no buffer space; will unblock when
		// buffer space is available.
		Send(item naming.VDLGlobReply) error
	}
}

// NamespaceGlobContext represents the context passed to Namespace.Glob.
type NamespaceGlobContext interface {
	ipc.ServerContext
	NamespaceGlobServerStream
}

// NamespaceGlobContextStub is a wrapper that converts ipc.StreamServerCall into
// a typesafe stub that implements NamespaceGlobContext.
type NamespaceGlobContextStub struct {
	ipc.StreamServerCall
}

// Init initializes NamespaceGlobContextStub from ipc.StreamServerCall.
func (s *NamespaceGlobContextStub) Init(call ipc.StreamServerCall) {
	s.StreamServerCall = call
}

// SendStream returns the send side of the Namespace.Glob server stream.
func (s *NamespaceGlobContextStub) SendStream() interface {
	Send(item naming.VDLGlobReply) error
} {
	return implNamespaceGlobContextSend{s}
}

type implNamespaceGlobContextSend struct {
	s *NamespaceGlobContextStub
}

func (s implNamespaceGlobContextSend) Send(item naming.VDLGlobReply) error {
	return s.s.Send(item)
}
